<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8" />
    <title>Follow ME</title>
    <link rel="stylesheet" href="style.css" />
  </head>
  <body>
    <nav>
      <ul class="menu">
        <li><a href="">Home</a></li>
        <li><a href="">Order Status</a></li>
        <li><a href="">Tweets</a></li>
        <li><a href="">Read Our History</a></li>
        <li><a href="">Contaxt Us</a></li>
      </ul>
    </nav>

    <div class="wrapper">
      <p>
        Lorem ipsum dolor sit amet, <a href="">consectetur</a> adipisicing elit. Est <a href="">explicabo</a> unde natus
        necessitatibus esse obcaecati distinctio, aut itaque, qui vitae!
      </p>
      <p>
        Aspernatur sapiente quae sint <a href="">soluta</a> modi, atque praesentium laborum pariatur earum
        <a href="">quaerat</a> cupiditate consequuntur facilis ullam dignissimos, aperiam quam veniam.
      </p>
      <p>
        Cum ipsam quod, incidunt sit ex <a href="">tempore</a> placeat maxime <a href="">corrupti</a> possimus
        <a href="">veritatis</a> ipsum fugit recusandae est doloremque? Hic, <a href="">quibusdam</a>, nulla.
      </p>
      <p>
        Esse quibusdam, ad, ducimus cupiditate <a href="">nulla</a>, quae magni odit <a href="">totam</a> ut consequatur
        eveniet sunt quam provident sapiente dicta neque quod.
      </p>
      <p>
        Aliquam <a href="">dicta</a> sequi culpa fugiat <a href="">consequuntur</a> pariatur optio ad minima, maxime
        <a href="">odio</a>, distinctio magni impedit tempore enim repellendus <a href="">repudiandae</a> quas!
      </p>
    </div>

    <script>
      // a 태그들을 관찰하기 위함
      const triggers = document.querySelectorAll("a");

      // 하이라이트 전용 span 태그 만듬
      const highlight = document.createElement("span");

      // 최초에 속성 부여 및 생성
      highlight.classList.add("highlight");
      document.body.appendChild(highlight);

      function highlightLink() {
        // 요소에 대한 위치/크기 값 가져오기
        const linkCoords = this.getBoundingClientRect();

        // 위치 찾아내기
        const coords = {
          width: linkCoords.width,
          height: linkCoords.height,
          top: linkCoords.top + window.scrollY,
          left: linkCoords.left + window.scrollX,
        };

        highlight.style.width = `${coords.width}px`;
        highlight.style.height = `${coords.height}px`;

        // 위치 이동
        // transition 의 룰대로 천천히 움직임, 움직이는 모습 관찰 가능
        highlight.style.transform = `translate(${coords.left}px, ${coords.top}px)`;
      }

      triggers.forEach((a) => a.addEventListener("mouseenter", highlightLink));
    </script>
  </body>
</html>
